
set echo on
set serveroutput on

set autotrace traceonly statistics

SELECT * FROM t;
SELECT * FROM t;

set timing on
set arrays 500

SELECT grp
,      LISTAGG(val, ',') WITHIN GROUP (ORDER BY val) AS vals
FROM   t
GROUP  BY
       grp;

SELECT grp
,      WMSYS.WM_CONCAT(val) AS vals --<-- WM_CONCAT ~= STRAGG
FROM   t
GROUP  BY
       grp;

SELECT grp
,      TO_STRING(
          CAST(COLLECT(val ORDER BY val) AS varchar2_ntt)
          ) AS vals
FROM   t
GROUP  BY
       grp;

SELECT grp
,      TO_STRING(
          CAST(COLLECT(val) AS varchar2_ntt)
          ) AS vals
FROM   t
GROUP  BY
       grp;

SELECT grp
,      vals
FROM  (
       SELECT grp
       ,      LTRIM(vals, ',') AS vals
       FROM   t
       MODEL
          RETURN UPDATED ROWS
          PARTITION BY (grp)
          DIMENSION BY (ROW_NUMBER() OVER (PARTITION BY grp ORDER BY val) AS rn)
          MEASURES (CAST(val AS VARCHAR2(4000)) AS vals)
          RULES ITERATE (2000) 
             UNTIL (PRESENTV(vals[ITERATION_NUMBER+1],1,0) = 0)
             (
                 vals[0] = CASE ITERATION_NUMBER
                              WHEN 0
                              THEN vals[0]
                              ELSE vals[0] || ',' || vals[ITERATION_NUMBER]
                           END
             )
      )
ORDER  BY
       grp;

SELECT grp
,      vals
FROM  (
       SELECT grp
       ,      RTRIM(vals, ',') AS vals
       ,      rn
       FROM   t
       MODEL
          PARTITION BY (grp)
          DIMENSION BY (ROW_NUMBER() OVER (PARTITION BY grp ORDER BY val) AS rn)
          MEASURES (CAST(val AS VARCHAR2(4000)) AS vals)
          RULES
          (  vals[ANY] ORDER BY rn DESC = vals[CV()] || ',' || vals[CV()+1]
          )
      )
WHERE  rn = 1
ORDER  BY
       grp;

set autotrace off

